//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//

// ChildView.h : CChildView NX̃C^[tFCX
//


#pragma once
#include "Editor.h"

#include "BottomBar.h"

#include "mrulist.h"

#define	IDM_MRU_START	50000
#define	IDM_MRU_END		50040

// CChildView EBhE
class	CReadBuff {
private:
	TCHAR	*m_readbuff;
	int		m_buffptr;
	int		m_buffsize;
	bool	m_bufferr;
	HANDLE	m_hMmap;
#define	BLOCKSIZE	65536*4*4*32
private:
	void*	Alloc( int size , HANDLE *hMap ){
		void *buff = NULL;
		*hMap = CreateFileMapping((HANDLE)INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE|SEC_COMMIT,0,size,NULL );
		if ( *hMap != NULL ){
			buff = MapViewOfFile( *hMap , FILE_MAP_WRITE , 0 , 0 , 0 );
		}
		return buff;
	}

	void	Free( void *ptr , HANDLE hMap ){
		if ( hMap != NULL ){
			if ( ptr !=NULL ){
				UnmapViewOfFile( ptr );
			}
			CloseHandle(hMap);
		}
	}


public:
	CReadBuff(){
		m_bufferr = true;
		m_buffsize = BLOCKSIZE;
		//m_readbuff = (TCHAR*)VirtualAlloc(NULL,m_buffsize*sizeof(TCHAR),MEM_COMMIT,PAGE_EXECUTE_READWRITE);
		// virtualallocgĂ32MB̕ǂzȂorz
		//m_readbuff = new TCHAR[m_buffsize];
		m_readbuff = (TCHAR*)Alloc( m_buffsize*sizeof(TCHAR) , &m_hMmap );

		if ( m_readbuff !=NULL ){
			m_buffptr = 0;
			m_readbuff[0] = 0;
			m_bufferr = false;
		}
	}

	virtual	~CReadBuff()
	{
		if ( m_readbuff  != NULL ){
			//VirtualFree(m_readbuff ,0,MEM_RELEASE);
			//DELA( m_readbuff );
			Free( m_readbuff , m_hMmap );
		}
	}

	void	AddBuff(const TCHAR *p){
		if ( p==NULL || *p == 0 ){
			return;
		}

		int len = _tcslen(p);
		int bs = m_buffsize;
		while ( m_buffptr + len >= bs ){
			bs += BLOCKSIZE;
		}
		if ( bs != m_buffsize ){
			//TCHAR *newbuf = (TCHAR*)VirtualAlloc(NULL,bs*sizeof(TCHAR),MEM_COMMIT,PAGE_EXECUTE_READWRITE);
			//TCHAR *newbuf = new TCHAR[bs];
			HANDLE hMap;
			TCHAR *newbuf  = (TCHAR*)Alloc( bs*sizeof(TCHAR) , &hMap );

			if ( newbuf == NULL ){
				m_bufferr = true;
				//DELA( m_readbuff );
				Free( m_readbuff , m_hMmap );
				return;
			}
			CopyMemory( newbuf , m_readbuff , m_buffptr*sizeof(TCHAR) );

			//VirtualFree(m_readbuff ,0,MEM_RELEASE);
			//DELA( m_readbuff );
			Free( m_readbuff , m_hMmap );

			m_readbuff = newbuf;
			m_buffsize = bs;
		}

		_tcscpy( m_readbuff + m_buffptr , p );
		m_buffptr += len;
	}
	TCHAR	*GetBuff()
	{
		return m_readbuff;
	}
	int		GetLength()
	{
		return m_buffptr;
	}

	bool	IsError()
	{
		return m_bufferr;
	}
};

class CChildView : public CWnd,IUseBottomBar
{
// RXgNV
public:
	CChildView();
	virtual ~CChildView();

protected:
	// TEXT
	CEditor	m_Edit;
	CString	m_filename;		// t@C

	int m_charset;		// R[h
	int m_lbcode;		// sR[h
	CString	m_fontname;
	UINT	m_fontsize;
	UINT	m_tabsize;
	CFont	*m_pfont;
	//BOOL	m_allfile;
	BOOL	m_hscroll;
	DWORD	m_drawsymbol;
	const TCHAR	*GetFilter();
	TCHAR	m_filbuf[MAX_PATH];
	UINT	m_xscrawl;

	bool	m_findfirst;
	bool	m_charset_autodetect;				// R[hotO
	bool	m_validfilename;	// t@CLtO
	CBottomBar	*m_toolbar;
	HANDLE	m_hLock;	// rnh

	CMruList m_mrulist;
	int		m_mrunum;

protected:
	bool	OpenFile( const TCHAR *filename );	// t@Cǂݏo
	void	Savefile( const TCHAR *filename );	// t@Cۑ
	bool	SaveAs();							// t@Cۑ_CAO
	void	NewFile();							// VKt@C쐬
	bool	SaveOverwrite();					// ㏑ۑ
	void	SetTitle( BOOL modify );			// EChE^Cg


	void	SaveSettings();
	void	LoadSettings();

	void	ChangeFont();
	void	Layout();
	void	NotifyBottomBar(UINT endcode,CString *p1 , CString *p2);

	HWND	LockFile(HWND hWnd,CString fname);
	void	UnlockFile();
	
	void	LoadMruList();
	void	SaveMruList();

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

	afx_msg LRESULT OnTextChanged(WPARAM wp, LPARAM lp);
	afx_msg LRESULT OnNotifyFocus(WPARAM wp, LPARAM lp);
	afx_msg void OnFileSaveas();
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen();
	afx_msg void OnFileNew();
	afx_msg void OnCharsetAutodetect();
	afx_msg void OnUpdateCharsetAutodetect(CCmdUI *pCmdUI);
	afx_msg BOOL OnCharset(UINT nID);
	afx_msg void OnUpdateCharset(CCmdUI *pCmdUI);
	afx_msg BOOL OnLb(UINT nID);
	afx_msg void OnUpdateLb(CCmdUI *pCmdUI);

	afx_msg void OnToolOption();
	afx_msg void OnJumpLineno();

	afx_msg void OnSearchSearch();
	afx_msg void OnSearchReplace();
	afx_msg void OnFileReopen();
	afx_msg void OnUpdateFileReopen(CCmdUI *pCmdUI);
	afx_msg void OnMruOpen(UINT nID);
public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	BOOL	m_menutenkey;
	bool	ConfirmSave();						// ۑmF
	void	SetMruMenu(int menuno , HMENU hmenu);

};

