//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//
#pragma once

class CMruList
{
private:
	class CMru {
	public:
		CString	filename;
		int	pos;
		CMru( ){pos =0;}
		CMru( const TCHAR*f , int p ){
			filename = f;
			pos = p;
		}
	};
	CList<CMru>	m_list;
	int	m_max;
	POSITION	GetPosition( const TCHAR *filename );
public:
	CMruList(int max);
	virtual ~CMruList(void);
	void	Add( const TCHAR*filename , int p=0 );
	void	AddTail( const TCHAR*filename , int p=0 );
	void	Remove( const TCHAR*filename );
	int	GetCount(){
		return m_list.GetCount();
	}
	int	GetMax(){	return m_max; }
	const TCHAR	*GetFilename( int i ){
		POSITION pos = m_list.FindIndex(i);
		return m_list.GetAt(pos).filename;
	}
	int	GetPos( int i ){
		POSITION pos = m_list.FindIndex(i);
		return m_list.GetAt(pos).pos;
	}
	int	GetPos( const TCHAR *filename )
	{
		POSITION pos = GetPosition( filename );
		if ( pos!=NULL ){
			CMru mru = m_list.GetAt(pos);
			return mru.pos;
		}
		return 0;
	}
};
