/*
 * nEdit
 *
 * nEdit.h
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_NEDIT_H
#define _INC_NEDIT_H

#ifdef __cplusplus
extern "C" {
#endif


/* Include Files */
#include <windows.h>
#include <tchar.h>
#ifdef OP_XP_STYLE
#include <uxtheme.h>
#include <tmschema.h>
#endif	// OP_XP_STYLE

/* Define */
#define NEDIT_WND_CLASS					TEXT("nEdit")

#define WM_GETBUFFERINFO				(WM_APP + 1)
#define WM_REFLECT						(WM_APP + 2)
#define WM_GETWORDWRAP					(WM_APP + 3)
#define WM_SETWORDWRAP					(WM_APP + 4)
#define WM_GETMEMSIZE					(WM_APP + 5)
#define WM_GETMEM						(WM_APP + 6)
#define WM_SETMEM						(WM_APP + 7)
#define WM_SETPLATFORM					(WM_APP + 8)
#define WM_DRAWSYMBOL					(WM_APP + 9)

#define EM_GETREADONLY					(WM_APP + 100)
#define WM_GETLOCALMEM					(WM_APP + 101)

#ifndef EM_REDO
#define EM_REDO							(WM_USER + 84)
#endif
#ifndef EM_CANREDO
#define EM_CANREDO						(WM_USER + 85)
#endif

#define UNDO_TYPE_INPUT					1
#define UNDO_TYPE_DELETE				2

#define	DS_LINEBREAK		(0x00000001)
#define DS_TAB				(0x00000002)
#define	DS_SPACE			(0x00000004)
#define DS_WIDESPACE		(0x00000008)

/* Struct */
typedef struct _UNDO {
	BYTE type;

	DWORD st;
	DWORD len;
	TCHAR *buf;
} UNDO;

typedef struct _BUFFER {
	// ێĂe
	TCHAR *buf;
	DWORD buf_size;
	DWORD buf_len;

	// ̓obt@
	TCHAR *input_buf;
	DWORD input_size;
	DWORD input_len;

	// \s̃ItZbg
	DWORD *line;
	int line_size;
	int line_len;
	int line_add_index;
	int line_add_len;

	// UNDOobt@
	UNDO *undo;
	int undo_size;
	int undo_len;
	int undo_pos;

	// ͊Jnʒu
	TCHAR *ip;
	DWORD ip_len;
	// 폜Jnʒu
	TCHAR *dp;
	DWORD del_len;

	// Lbg̈ʒu
	DWORD cp;
	// Iʒu
	DWORD sp;
	// ㉺ړ̃LbgXW
	int cpx;

	// 1s̕
	int line_max;
	// s̍ő啝
	int line_width;
	// EBhE̕
	int width;

	// XN[ o[
	int pos_x;
	int max_x;
	int pos_y;
	int max_y;

	// ^uXgbv
	int tab_stop;
	// }[W
	int left_margin;
	// }[W
	int top_margin;
	// E}[W
	int right_margin;
	// }[W
	int bottom_margin;
	// s
	int spacing;

	// `p
	HDC mdc;
	HBITMAP ret_bmp;
	HRGN hrgn;
	HFONT hfont;
	HFONT ret_font;

	// tHg
	int font_height;
	int char_width;

	// Lbg
	int	caret_width;

	// ܂ԂtO
	BOOL wordwrap;
	// tH[JXĂI\
	BOOL no_hide_sel;
	// ɕϊ
	BOOL lowercase;
	// 啶ɕϊ
	BOOL uppercase;
	// bNtO
	BOOL lock;
	// CtO
	BOOL modified;
	// ̓[h
	BOOL insert_mode;
	// ItO
	BOOL sel;
	// }EXtO
	BOOL mousedown;
	// ͒
	DWORD limit_len;
	// PI[h
	BOOL wordselect;
	// PĨLbg̈ʒu
	DWORD wordselect_cp;
	// PȊIʒu
	DWORD wordselect_sp;

	// ̕
	BYTE cwidth[0x10000];

	// Rg[ʎq
	int id;
	// IME
	HIMC himc;
	// R|WVEBhE
	HWND hCompWnd;

	// PPC/Smartphone[h
	int nPlatform;			// 0:PPC 1:Smartphone

	// L\
	DWORD	drawsymbol;

#ifdef OP_XP_STYLE
	// XP
	HMODULE hModThemes;
	HTHEME hTheme;
#endif	// OP_XP_STYLE

	// }bsO
#define	MAPNUM	16
	// }bsOnh
	HANDLE	hMmap[MAPNUM];
	// }bsO|C^
	void*	pMmap[MAPNUM];

} BUFFER;

/* Function Prototypes */
BOOL nedit_regist(const HINSTANCE hInstance);

#ifdef __cplusplus
}
#endif

#endif

/* End of source */
